#ifndef DRIVER_H
#define DRIVER_H

#include "stm32f10x.h"
#include "stm32f10x_conf.h"
#include "stm32f10x_it.h"
#include "usart.h"

// http://www.ti.com/lit/ds/symlink/sn74hc595.pdf
// http://www.hlvled.com/images/up_images/HL-M1388BR.pdf

#define CLK_PIN GPIO_Pin_0
#define LAT_PIN GPIO_Pin_1
#define DI1_PIN GPIO_Pin_8
#define DI2_PIN GPIO_Pin_4

#define K1_PIN GPIO_Pin_5
#define K2_PIN GPIO_Pin_6
#define K3_PIN GPIO_Pin_8
#define K4_PIN GPIO_Pin_9

#define DBG0_PIN GPIO_Pin_5
#define DBG1_PIN GPIO_Pin_9
#define DBG2_PIN GPIO_Pin_6
#define DBG3_PIN GPIO_Pin_7

#define side	8
#define width	8
#define height	16

void driver_init();
void driver_keyboard_irq (int line);
void driver_sys_tick();
void driver_draw (uint8_t *data);
void driver_delay (long long arg);
void driver_low (uint32_t arg);
void driver_hi (uint32_t arg);
void driver_toogle (int dir, uint32_t arg);
int driver_getkey (int key);

#endif
